#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "math.h"

#define MAXFIELDS 10000
#define MAXLINE 150
#define MAXLABELSIZE 50


struct _vertices_ {
	int subNumber;
	int subCode;
	int vertexNumber;
	char vertexLabel[MAXLABELSIZE];
} vertices[50000], vertex;

struct _edges_ {
	int subNumber;
	char edgeType[MAXLABELSIZE];
	int edgeFrom;
	int edgeTo;
	char edgeLabel[MAXLABELSIZE];
} edges[500000], edge;



int find_field(char line[MAXLINE],char fname[40])
{
int i,j,limit,fieldl,position,flag;

  i=0;
  j=0;
  limit=0;
  fieldl=0;
  position=0;
  flag=1;

  limit = strlen(line);
  fieldl = strlen(fname);

  flag = 1;
  i = 0;
  while (flag == 1 && i < limit)
  {
    flag = 0;
    for(j=0;j<fieldl;j++)
      if(line[i+j] != fname[j])
        flag = 1;
    i++;
  }

  if (flag == 0)
    position = i - 1;
  else
    position = -1;

  return position;
}




int main (int argc, char *argv[])
{
  FILE *dfp;
  int i,j,k,l,llong,nline;
  char line[MAXLINE];
  char *tmp;

  int subCounter;
  int subCode;
  int verticesCounter;
  int edgesCounter;
  int vertexNumber;
  int edgeFrom;
  int edgeTo;
  int innerSub;
  int toFlag;
  int lastToEdge = 0;
  int lastToVertex = 0;
  int chainSize = 0;
  int toAdd = 0;
  char vertexLabel[MAXLABELSIZE];
  char edgeType[5];
  char edgeLabel[MAXLABELSIZE];
  char tmpField[MAXLABELSIZE];

  
  /* Variables initialization */
  strcpy(line,"");
  i = 0;
  j = 0;
  k = 0;
  l = 0;
  llong = 0;
  nline = 0;
  toFlag = 0;
  tmp = malloc(50);

  /* Arguments validation */
  if (argc != 2)
  {
    printf("Usage: PPSub filename\n");
    return 1;
  }
  /* Openning the data file */
  if ((dfp = fopen(argv[1],"r")) == NULL)
  {
    printf("Error at open file: %s\n",argv[1]);
    return 1;
  }
  else /*Giving values to the field names array */
  {
    /* Reading the data file */
    strcpy(line,"X");

    //fgets(line,MAXLINE,dfp);
    //llong = strlen(line);
   
	subCounter = 0;
	subCode = 0;
	verticesCounter = 0;
	edgesCounter = 0;
	toAdd = 0;

    while(fgets(line,MAXLINE,dfp) != NULL)
    {
		switch (line[0])
		{
		case 'v':		strcpy(tmpField,strtok(line," ")); // Read vertice
						strcpy(tmpField,strtok(NULL," "));
						vertexNumber = atoi(tmpField);
						strcpy(vertexLabel,strtok(NULL," "));
						strcat(vertexLabel,"\0");
						vertices[verticesCounter].subNumber = subCounter;
						vertices[verticesCounter].subCode = subCode;
						vertices[verticesCounter].vertexNumber = vertexNumber + toAdd;
						strcpy(vertices[verticesCounter].vertexLabel,vertexLabel);
						verticesCounter++;
						break;
						// Read edge.
		case 'd':		;
		case 'e':		;
		case 'u':		strcpy(edgeType,strtok(line," "));
						strcpy(tmpField,strtok(NULL," "));
						edgeFrom = atoi(tmpField);
						strcpy(tmpField,strtok(NULL," "));
						edgeTo = atoi(tmpField);
						strcpy(edgeLabel,strtok(NULL," "));

						strcpy(edges[edgesCounter].edgeType,edgeType);
						edges[edgesCounter].edgeFrom = edgeFrom + toAdd;
						edges[edgesCounter].edgeTo = edgeTo + toAdd;
						edges[edgesCounter].subNumber=subCounter;
						strcpy(edges[edgesCounter].edgeLabel,edgeLabel);
						edgesCounter++;
						break;
						// Start reading the next substructure.
		case 'X':		if ( line[1] == 'P' )
						  subCode = 0;
					else if ( line[1] == 'N' )
						  subCode = 1;
						subCounter++;
						toAdd = verticesCounter;
						break;
		default:		break;
		} //End switch
	} //End While








    fclose(dfp);
	for( i = 1; i <= subCounter; i++)
	{

		// Find the ith substructure 
		j = 0;
		while ( vertices[j].subNumber != i )
		{
			j++;
		}

		  if ( vertices[j].subCode == 0 )
		    printf("XP\n");
		  else
		    printf("XN\n");

		  // Print the Sub vertices
		  while ( vertices[j].subNumber == i )
		  {
		    printf("v %d %s",vertices[j].vertexNumber,vertices[j].vertexLabel);
		    j++;
		  }
		  

		  // Find the ith substructure edges 
		  j = 0;
		  while ( edges[j].subNumber != i )
		  {
			j++;
		  }

		  // Print the ith substructure edges
		  while ( edges[j].subNumber == i )
		  {
			printf("%s %d %d %s",edges[j].edgeType, edges[j].edgeFrom, edges[j].edgeTo, edges[j].edgeLabel);
			j++;
		  }
	} //End for

  } // End else validation
  return 0;
} // End main
